package bsh.script;
import java.util.*;
import javax.script.*;
import bsh.NameSpace;
import bsh.Variable;

public class BeanShellBindings extends NameSpace implements Bindings {

  public BeanShellBindings(NameSpace parent,String name) {
    super(parent,name);
  }

  public boolean containsKey(Object key) {
    try {
      return getVariableImpl(key.toString(),true) != null;
    }
    catch(Exception ex) {
      ex.printStackTrace();
      return false;
    }
  }

  public Object get(Object key) {
    try {
      return getVariable(key.toString());
    }
    catch(Exception ex) {
      ex.printStackTrace();
      return null;
    }
  }

  public Object put(String name,Object value) {
    Object oval = get(name);
    try {
      setVariable(name,value,true);
      return oval;
    }
    catch(Exception ex) {
      ex.printStackTrace();
      return null;
    }
  }

  public void putAll(Map<? extends String,? extends Object> toMerge) {
    for(String key : toMerge.keySet())
      put(key,toMerge.get(key));
  }

  public Object remove(Object key) {
    Object val = get(key);
    unsetVariable(key.toString());
    return val;
  }

  /** Map interface that may not be required { */
  public void clear() {
  }

  public boolean containsValue(Object value) {
    return false;
  }

  public Set entrySet() {
    return null;
  }

  public boolean isEmpty() {
    return false;
  }

  public Set keySet() {
    return null;
  }

  public int size() {
    return 0;
  }

  public Collection values() {
    return null;
  }
  /** Map interface } */
}
